# Proceduren zur Behandlung von FITS Dateien 
# Version: 27.7.1998
# Diese Library ist Bestandteil des AstroIx Programmpaketes
# Copyright (c) 1998 Xaman Ek Xols
# Autor: Wolfgang Pawlowski

set FITS_HEADERLENGHT 36
global fh_feld 
array set fits {pfad {""} SIMPLE {""} NAXIS {0} BITPIX {0} NAXIS1 {0} NAXIS2 {0} DATAMIN {0} DATAMAX {0} BZERO {0.0} BSCALE {0.0} DATE-OBS {""} UT {""} INSTRUME {""} EXPTIME {0.0} HISTORY {""} OBJECT {""} TELESCOP {""}}  
array set fitsnames { 0 {NAXIS} 1 {BITPIX} 2 {NAXIS1} 3 {NAXIS2} 4 {DATAMIN} 5 {DATAMAX} 6 {BZERO} 7 {BSCALE} 8 {EXPTIME} 9 {SIMPLE} 10 {DATE-OBS}  11 {UT} 12 {INSTRUME} 13 {OBJECT} 14 {TELESCOP} 15 {HISTORY}}  
array set fitszeile { Schluessel {""} Wert {""} Kommentar {""}}

proc fitszeile> {str} {
	global fitszeile
	set str1 ""
	set str2 ""
	set str3 ""
	set str1 [string range $str 0 7]
	if {($str1 == "        ") || ($str1 == "HISTORY") || ($str1 == "COMMENT")} {
		set str2 [string range $str 8 end]
	} else {
		set str2 [string range $str 10 end]
		set zwi [string range $str 10 10]
		if {$zwi == "'"} {
			set indi [string last "'" $str]
			set str2 [string range $str 10 $indi]
			set str3 [string range $str [expr $indi + 1] end]
			set indi [string last "/" $str3]
			if {$indi != -1} {
				set str3 [string range $str3 [expr $indi + 1] end]
			} 
		} else {
			set indi [string last "/" $str]
			if {$indi != -1} {
				set str3 [string range $str [expr $indi + 1] end]
				set str2 [string range $str 10 [expr $indi - 1]]
			}
		} 
	}
	set str2 [string trim $str2 "'"]
	set fitszeile(Schluessel) $str1
	set fitszeile(Wert) $str2
	set fitszeile(Kommentar) $str3
}

proc fitszeile< {} {
	global fitszeile
	set m ""
	set mitte "= "
	set apos "'"
	set kommi "/"
	if {($str1 == "        ") || ($str1 == "HISTORY") || ($str1 == "COMMENT")} {
		set str "$fitszeile(Schluessel)$fitszeile(Wert)$fitszeile(Kommentar)"
	} else {
		scan $fitszeile(Wert) %\[^0123456789eE.+-\] m
		if {$m == ""} {
			set str "$fitszeile(Schluessel)$mitte$kommi$fitszeile(Kommentar)"
		} else {
			set str "$fitszeile(Schluessel)$mitte$apos$fitszeile(Wert)$apos$kommi$fitszeile(Kommentar)"
		}
	}
	return $str
}

proc fitsheader {file} {
	global fh_feld FITS_HEADERLENGHT
        set NUM_LINES 36
        set FITSLINE  80
	set fitslines 0
        set out true
	set f_in [open [file join "$file"]]
	while {$out} {
		incr fitslines
		set str [read $f_in $FITSLINE]
		set fstr [string trimright $str " "]
                set fh_feld($fitslines) $fstr 
		if {[string range $fstr 0 2] == "END"} {
			set out false
		}
	}
	close $f_in
	set FITS_HEADERLENGHT $fitslines
}

proc fitsheader_daten {} {
	global fits fh_feld FITS_HEADERLENGHT fitsnames
	set i 1
	while {$i != $FITS_HEADERLENGHT} {
		for {set j 0} {$j < 6} {incr j} {
			if {[string trimright [string range $fh_feld($i) 0 7] " "] == $fitsnames($j)} {
				scan [string trim [string range $fh_feld($i) 9 end] " "] %d fits($fitsnames($j)) 
				set j 6
			}
		}
		for {set j 6} {$j < 9} {incr j} {
			if {[string trimright [string range $fh_feld($i) 0 7] " "] == $fitsnames($j)} {
				scan [string trim [string range $fh_feld($i) 9 end] " "] %e fits($fitsnames($j)) 
				set j 9
			}
		}
		if {[string trimright [string range $fh_feld($i) 0 7] " "] == $fitsnames(9)} {
				set b [expr [string last "/" [string range $fh_feld($i) 0 end]] - 1]
				set fits($fitsnames(9)) [string trim [string range $fh_feld($i) 11 $b] " "]
		}
		for {set j 10} {$j < 16} {incr j} {
			if {[string trimright [string range $fh_feld($i) 0 7] " "] == $fitsnames($j)} {
				set a [expr [string first "'" [string range $fh_feld($i) 0 end]] + 1]
				set b [expr [string last "'" [string range $fh_feld($i) 0 end]] - 1]
				set fits($fitsnames($j)) [string trim [string range $fh_feld($i) $a $b] " "]
				set j 16   
			}
		}
		incr i
 	}
}

proc clear_fits {} {
	global fits fitsnames
	for {set i 0} {$i < 6} {incr i} {
		set fits($fitsnames($i)) 0
	}
	for {set i 6} {$i < 9} {incr i} {
		set fits($fitsnames($i)) 0.0
	}
	for {set i 9} {$i < 16} {incr i} {
		set fits($fitsnames($i)) ""
	}
}
