# Berechnungsroutienen fr die Nutation in der Lnge, Nutation der Schiefe der Ekliptik,
# mittlere und wahre Ekliptik
# Version: 18.11.1997
# Diese Library ist Bestandteil des AstroIx Programmpaketes
# Copyright (c) 1997 Xaman Ek Xols
# Autor: Wolfgang Pawlowski

proc gradintervall {was} {
  set out $was
  if {$was > 360} {
    set out [expr $was - (int($was / 360) * 360.0)]
  }
  if {$was < 0} {
    set out [expr $was - ((int($was / 360) - 1) * 360.0)]
  }
  return $out
}

# Nutation in Lnge: Eingabe Julianischer Tag; Ausgabe in Bogensekunden 
proc Nutation_L {jde} {
  global const_pi  
  set t  [expr ($jde - 2451545.0) / 36525.0]
  set d  [expr 297.85036 + $t * (445267.111480 + $t * (-0.0019142 + ($t / 189474.0)))]
  set d  [expr $const_pi * [gradintervall $d] / 180.0]
  set m  [expr 357.52772 + $t * (35999.050340 + $t * (-0.0001603 - ($t / 300000.0)))]
  set m  [expr $const_pi * [gradintervall $m] / 180.0]
  set mm [expr 134.96298 + $t * (477198.867398 + $t * (0.0086972 + ($t /  56250.0)))]
  set mm [expr $const_pi * [gradintervall $mm] / 180.0]
  set f  [expr 93.27191 + $t * (483202.017538 + $t * (-0.0036825 + ($t / 327270.0)))]
  set f  [expr $const_pi * [gradintervall $f] / 180.0]
  set o  [expr 125.04452 - $t * (1934.136261 + $t * (0.0020708 + ($t / 450000.0)))]
  set o  [expr $const_pi * [gradintervall $o] / 180.0]
                
  set phi [expr       (-17.1996 - 0.01742 * $t) * sin($o)]
  set phi [expr $phi + (-1.3187 - 0.00016 * $t) * sin(2.0 * $f + 2.0 * $o - 2.0 * $d)]
  set phi [expr $phi + (-0.2274 - 0.00002 * $t) * sin(2.0 * $f + 2.0 * $o)]
  set phi [expr $phi + ( 0.2062 + 0.00002 * $t) * sin(2.0 * $o)]
  set phi [expr $phi + ( 0.1426 - 0.00034 * $t) * sin($m)]
  set phi [expr $phi + ( 0.0712 + 0.00001 * $t) * sin($mm)]
  set phi [expr $phi + (-0.0517 + 0.00012 * $t) * sin($m + 2.0 * $f + 2.0 * $o - 2.0 * $d)]
  set phi [expr $phi + (-0.0386 - 0.00004 * $t) * sin(2.0 * $f + $o)]
  set phi [expr $phi + (-0.0301)                * sin($mm + 2.0 * $f + 2.0 * $o)]
  set phi [expr $phi + ( 0.0217 - 0.00005 * $t) * sin(2.0 * $f + 2.0 * $o - $m - 2.0 * $d)]
  set phi [expr $phi + (-0.0158)                * sin($mm - 2.0 * $d)]
  set phi [expr $phi + ( 0.0129 + 0.00001 * $t) * sin(2.0 * $f + $o - 2.0 * $d)]
  set phi [expr $phi + ( 0.0123)                * sin(2.0 * $f - $mm + 2.0 * $o)]
  set phi [expr $phi +   0.0063                 * sin(2.0 * $d)]
  set phi [expr $phi + ( 0.0063 + 0.00001 * $t) * sin($mm + $o)]
  set phi [expr $phi + (-0.0059)                * sin(2.0 * $d - $mm + 2.0 * $f + 2.0 * $o)]
  set phi [expr $phi + (-0.0058 - 0.00001 * $t) * sin($o - $mm)]
  set phi [expr $phi + (-0.0051)                * sin($mm + 2.0 * $f + $o)]
  set phi [expr $phi +   0.0048                 * sin(2.0 * $mm - 2.0 * $d)]
  set phi [expr $phi +   0.0046                 * sin($o + 2.0 * $f - 2.0 * $mm)]
  set phi [expr $phi + (-0.0038)                * sin(2.0 * $d + 2.0 * $f + 2.0 * $o)]
  set phi [expr $phi + (-0.0031)                * sin(2.0 * $mm + 2.0 * $f + 2.0 * $o)]
  set phi [expr $phi +   0.0029                 * sin(2.0 * $mm)]
  set phi [expr $phi +   0.0029                 * sin($mm - 2.0 * $d + 2.0 * $f + 2.0 * $o)]
  set phi [expr $phi +   0.0026                 * sin(2.0 * $f)]
  set phi [expr $phi -   0.0022                 * sin(2.0 * $f - 2.0 * $d)]
  set phi [expr $phi +   0.0021                 * sin($o + 2.0 * $f - $mm)]
  set phi [expr $phi + ( 0.0017 - 0.00001 * $t) * sin(2.0 * $m)]
  set phi [expr $phi +   0.0016                 * sin(2.0 * $d - $mm + $o)]
  set phi [expr $phi + (-0.0016 + 0.00001 * $t) * sin(2.0 * $o + 2.0 * $f + 2.0 * $m - 2.0 * $d)]
  set phi [expr $phi -   0.0015                 * sin($m + $o)]
  set phi [expr $phi -   0.0013                 * sin($o + $mm - 2.0 * $d)]
  set phi [expr $phi -   0.0012                 * sin($o - $m)]
  set phi [expr $phi +   0.0011                 * sin(2.0 * $mm - 2.0 * $f)]
  set phi [expr $phi -   0.0010                 * sin(2.0 * $d - $mm + 2.0 * $f + $o)]
  set phi [expr $phi -   0.0008                 * sin(2.0 * $d + $mm + 2.0 * $f + 2.0 * $o)]
  set phi [expr $phi +   0.0007                 * sin($m + 2.0 * $f + 2.0 * $o)]
  set phi [expr $phi -   0.0007                 * sin($mm + $m - 2.0 * $d)]
  set phi [expr $phi -   0.0007                 * sin(2.0 * $o + 2.0 * $f - $m)]
  set phi [expr $phi -   0.0007                 * sin(2.0 * $d + 2.0 * $f + $o)]
  set phi [expr $phi +   0.0006                 * sin(2.0 * $d + $mm)]
  set phi [expr $phi +   0.0006                 * sin(2.0 * $o + 2.0 * $f + 2.0 * $mm - 2.0 * $d)]
  set phi [expr $phi +   0.0006                 * sin($o + 2.0 * $f + $mm - 2.0 * $d)]
  set phi [expr $phi -   0.0006                 * sin(2.0 * $d - 2.0 * $mm + $o)]
  set phi [expr $phi -   0.0006                 * sin(2.0 * $d + $o)]
  set phi [expr $phi +   0.0005                 * sin($mm - $m)]
  set phi [expr $phi -   0.0005                 * sin($o + 2.0 * $f - $m - 2.0 * $d)]
  set phi [expr $phi -   0.0005                 * sin($o - 2.0 * $d)]
  set phi [expr $phi -   0.0005                 * sin(2.0 * $mm + 2.0 * $f + $o)]
  set phi [expr $phi +   0.0004                 * sin($o + 2.0 * $mm - 2.0 * $d)]
  set phi [expr $phi +   0.0004                 * sin($o + 2.0 * $f + $m - 2.0 * $d)]
  set phi [expr $phi +   0.0004                 * sin($mm - 2.0 * $f)]
  set phi [expr $phi -   0.0004                 * sin($mm - $d)]
  set phi [expr $phi -   0.0004                 * sin($m - 2.0 * $d)]
  set phi [expr $phi -   0.0004                 * sin($d)]
  set phi [expr $phi +   0.0003                 * sin($mm + 2.0 * $f)]
  set phi [expr $phi -   0.0003                 * sin(2.0 * $o + 2.0 * $f - 2.0 * $mm)]
  set phi [expr $phi -   0.0003                 * sin($mm - $m - $d)]
  set phi [expr $phi -   0.0003                 * sin($m + $mm)]
  set phi [expr $phi -   0.0003                 * sin(2.0 * $o + 2.0 * $f + $mm - $m)]
  set phi [expr $phi -   0.0003                 * sin(2.0 * $d - $m - $mm + 2.0 * $f + 2.0 * $o)]
  set phi [expr $phi -   0.0003                 * sin(3.0 * $mm + 2.0 * $f + 2.0 * $o)]
  set phi [expr $phi -   0.0003                 * sin(2.0 * $d - $m + 2.0 * $f + 2.0 * $o)]
  set phix [expr round($phi * 10000)]
  set phi [expr $phix / 10000.0]
  return $phi
}

# Nutation in der Schiefe der Ekliptik: Eingabe Julianischer Tag; Ausgabe in Bogensekunden 
proc Nutation_S_E {jde} {
  global const_pi  
  set t  [expr ($jde - 2451545.0) / 36525.0]
  set d  [expr 297.85036 + $t * (445267.111480 + $t * (-0.0019142  + ($t  / 189474.0)))]
  set d  [expr $const_pi * [gradintervall $d] / 180.0]
  set m  [expr 357.52772 + $t * (35999.050340 + $t * (-0.0001603 + ($t / 300000.0)))]
  set m  [expr $const_pi * [gradintervall $m] / 180.0]
  set mm [expr 134.96298 + $t * (477198.867398 + $t *(0.0086972 + ($t /  56250.0)))]
  set mm [expr $const_pi * [gradintervall $mm] / 180.0]
  set f  [expr 93.27191 + $t * (483202.017538 + $t * (-0.0036825 + ($t / 327270.0)))]
  set f  [expr $const_pi * [gradintervall $f] / 180.0]
  set o  [expr 125.04452 - $t * (1934.136261 + $t * (0.0020708 + ($t / 450000.0)))]
  set o  [expr $const_pi * [gradintervall $o] / 180.0]

  set eps [expr (+9.2025 + 0.00089 * $t) * cos($o)]
  set eps [expr $eps + (+0.5736 - 0.00031 * $t) * cos(2.0 * $f + 2.0 * $o - 2.0 * $d)]
  set eps [expr $eps + (+0.0977 - 0.00005 * $t) * cos(2.0 * $f + 2.0 * $o)]
  set eps [expr $eps + (-0.0895 + 0.00005 * $t) * cos(2.0 * $o)]
  set eps [expr $eps + ( 0.0054 - 0.00001 * $t) * cos($m)]
  set eps [expr $eps +  -0.0007                 * cos($mm)]
  set eps [expr $eps + ( 0.0224 - 0.00006 * $t) * cos($m + 2.0 * $f + 2.0 * $o - 2.0 * $d)]
  set eps [expr $eps +   0.0200                 * cos(2.0 * $f + $o)]
  set eps [expr $eps + ( 0.0129 - 0.00001 * $t) * cos($mm + 2.0 * $f + 2.0 * $o)]
  set eps [expr $eps + (-0.0095 + 0.00003 * $t) * cos(2.0 * $f + 2.0 * $o - $m - 2.0 * $d)]
  set eps [expr $eps -   0.0070                 * cos(2.0 * $f + $o - 2.0 * $d)]
  set eps [expr $eps -   0.0053                 * cos(2.0 * $f - $mm + 2.0 * $o)]
  set eps [expr $eps -   0.0033                 * cos($mm + $o)]
  set eps [expr $eps +   0.0026                 * cos(2.0 * $d - $mm + 2.0 * $f + 2.0 * $o)]
  set eps [expr $eps +   0.0032                 * cos($o - $mm)]
  set eps [expr $eps +   0.0027                 * cos($mm + 2.0 * $f + $o)]
  set eps [expr $eps -   0.0024                 * cos($o + 2.0 * $f - 2.0 * $mm)]
  set eps [expr $eps +   0.0016                 * cos(2.0 * $d + 2.0 * $f + 2.0 * $o)]
  set eps [expr $eps +   0.0013                 * cos(2.0 * $mm + 2.0 * $f + 2.0 * $o)]
  set eps [expr $eps -   0.0012                 * cos($mm - 2.0 * $d + 2.0 * $f + 2.0 * $o)]
  set eps [expr $eps -   0.0010                 * cos($o + 2.0 * $f - $mm)]
  set eps [expr $eps -   0.0008                 * cos(2.0 * $d - $mm + $o)]
  set eps [expr $eps +   0.0007                 * cos(2.0 * $o + 2.0 * $f + 2.0 * $m - 2.0 * $d)]
  set eps [expr $eps +   0.0009                 * cos($m + $o)]
  set eps [expr $eps +   0.0007                 * cos($o + $mm - 2.0 * $d)]
  set eps [expr $eps +   0.0006                 * cos($o - $m)]
  set eps [expr $eps +   0.0005                 * cos(2.0 * $d - $mm + 2.0 * $f + $o)]
  set eps [expr $eps +   0.0003                 * cos(2.0 * $d + $mm + 2.0 * $f + 2.0 * $o)]
  set eps [expr $eps -   0.0003                 * cos($m + 2.0 * $f + 2.0 * $o)]
  set eps [expr $eps +   0.0003                 * cos(2.0 * $o + 2.0 * $f - $m)]
  set eps [expr $eps +   0.0003                 * cos(2.0 * $d + 2.0 * $f + $o)]
  set eps [expr $eps -   0.0003                 * cos(2.0 * $o + 2.0 * $f + 2.0 * $mm -  2.0 * $d)]
  set eps [expr $eps -   0.0003                 * cos($o + 2.0 * $f + $mm - 2.0 * $d)]
  set eps [expr $eps +   0.0003                 * cos(2.0 * $d - 2.0 * $mm + $o)]
  set eps [expr $eps +   0.0003                 * cos(2.0 * $d + $o)]
  set eps [expr $eps +   0.0003                 * cos($o + 2.0 * $f - $m - 2.0 * $d)]
  set eps [expr $eps +   0.0003                 * cos($o - 2.0 * $d)]
  set eps [expr $eps +   0.0003                 * cos(2.0 * $mm + 2.0 * $f + $o)]
  set epsx [expr round($eps * 10000)]
  set eps [expr $epsx / 10000.0]
  return $eps
}

# Mittlere Schiefe der Ekliptik: Eingabe Julianischer Tag; Ausgabe in Bogensekunden 
proc Mittlere_Ekliptik {jde} {
  set u [expr ($jde - 2451545.0) / 3652500.0]
  if {[expr abs($u)] < 1} {
    set ekl 84381.448
    set ekl [expr $ekl - $u * (4680.93 - $u * (1.55 + $u * (1999.25 - $u * (51.38 - $u * (249.67 - $u * (39.05 + $u * (7.12 + $u * (27.87 + $u * (5.79 + 2.45 * $u)))))))))]
    set eklx [expr round($ekl * 1000)]
    set ekl [expr $eklx / 1000.0]
    return $ekl
  } else {
    error "Auerhalb des gltigen Zeitraumes! (-8000v.Chr...12000n.Chr.)"
  }
}

# Wahre Schiefe der Ekliptik: Eingabe Julianischer Tag; Ausgabe in Bogensekunden 
proc Wahre_Ekliptik {jde} {
  set eps [Nutation_S_E $jde]
  set ekl [Mittlere_Ekliptik $jde]
  set ekl [expr $ekl + $eps]
  set eklx [expr round($ekl * 1000)]
  set ekl [expr $eklx / 1000.0]
  return $ekl
}

