# Routienen bezglich der atmosphrischen Refraktion.
# Version: 10.12.1997
# Diese Library ist Bestandteil des AstroIx Programmpaketes
# Copyright (c) 1997 Xaman Ek Xols
# Autor: Wolfgang Pawlowski

#Eingabe: Scheinbare Hhe, Druck in hPa, Temperatur in Grad Celsius.
#Ausgabe: Wahre Hhe mit einem Fehler von 0.9"; Nach dieser Formel ist r im Zenit nicht Null!
proc wHoehe {hoehe p temp} {
  global const_pi  
  set a [expr 7.31 / ($hoehe + 4.4)]
  set b [expr tan($const_pi * ($hoehe + $a) / 180.0)]
  set r [expr 1.0 / $b]
  set r [expr $r + (-0.06 * sin($const_pi * (14.7 * $r + 13.0) / 180.0))]
  if {$p != -1} {
    set r [expr $r * ($p / 1010.0) * (283.0 / (273.0 + $temp))] 
  }
  set wh [expr $hoehe - ($r / 60.0)]
  return $wh
}

#Eingabe: Wahre Hhe, Druck in hPa, Temperatur in Grad Celsius.
#Ausgabe: Scheinbare Hhe mit einem Fehler von 4"; Nach dieser Formel ist r im Zenit nicht Null!
proc sHoehe {hoehe p temp} {
  global const_pi  
  set a [expr 10.3 / ($hoehe + 5.11)]
  set b [expr tan($const_pi * ($hoehe + $a) / 180.0)]
  set r [expr 1.02 / $b]
  if {$p != -1} {
    set r [expr $r * ($p / 1010.0) * (283.0 / (273.0 + $temp))] 
  }
  set sh [expr $hoehe + ($r / 60.0)]
  return $sh
}